' ************************************
' *** ***
' *** Reaktiv-Tiny v0.1 24/11/2005 ***
' *** ***
' ************************************
$regfile = "Attiny13.DAT"
$crystal = 113000			  'Reale Frequenz des internen 128kHz-Oszillators

$hwstack = 6 			      'sram Compilerfehler vermeiden
Config Portb = &B00011000 		 'Pinb.3 und .4 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = &B11100111 			'Pullups zuschalten, auer fr Pinb.3 und .4
Stop Adc 				  'A/D-Wandler abschalten, um Strom zu sparen
Stop Ac 				   'Analog-Komparator abschalten, um Strom zu sparen

Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim Led_ladezustand As Bit
Dim Hell As Bit
Dim Dunkel As Bit
Dim Morse$ As String * 10 		 '10 Takte, die gemorst werden sollen
Dim S$ As String * 1 		      'Merken zum Morsen (aktueller Takt)

Do
	Gosub Led_abfrage
	If Led_ladezustand = 0 Then 
		Hell = 1 		  'Bei Licht Merker setzen
	End If
	If Hell = 1 And B < 255 Then 
		B = B + 1 		 'Wenn Merker gesetzt wurde, Zhler fr Lichtdauer erhhen (bis max. 255)
	End If
	If Led_ladezustand = 1 And Hell = 1 And B < 30 Then 'Wenn es wieder dunkel ist dann nachsehen fr wie lange
		Dunkel = 1 		'Merker Setzen
		For C = 0 To 5 	    'LED-Zustand mehrmals abfragen
			Gosub Led_abfrage
			If Led_ladezustand = 0 Then 
				Dunkel = 0 'Wenn wieder Hell dann Dunkel-Merker lschen
			End If
		Next C
		If Dunkel = 1 Then 
			Gosub Morsen       'Wenn Dunkel-Merker gesetzt Morsen
		End If
	End If
	If Led_ladezustand = 1 Then        'Bei Dunkelheit Merker und Zhler fr Lichtdauer lschen
		Hell = 0
		B = 0
	End If
Loop

Led_abfrage:
	Portb.3 = 0 		       'Portb.3 auf Masse schalten
	Portb.4 = 1 		       'Portb.4 auf +Ub schalten, um die LED zu 'laden'
	Waitus 1 			  'Ladezeit, kann ggf. noch verkleinert werden
	Config Portb.4 = Input 	    'Portb.4 nun zwecks Abfrage der LED-Ladung auf 'Eingang' schalten
	Portb.4 = 0 		       'Pullup abschalten, sonst geht's nicht!
	Waitms 20 			 'Entladezeit 20ms (100 ms) - je kleiner, je unempfindlicher
	Led_ladezustand = Pinb.4 	  'Ladezustand einlesen: '1' -> dunkel, '0' -> hell
	Config Portb.4 = Output 	   'Portb.4 wieder auf Ausgang schalten
	Portb.4 = 0 		       'Portb.4 auf Masse schalten
Return

Morsen:
	Morse$ = "--***--***" 	     'String aus 10 Zeichen * = kurz - = lang
	For A = 1 To 10 		   '10 Zeichen auslesen und auswerten
		S$ = Mid(morse$ , A , 1)   'Teilstring auslesen
		If S$ = "*" Then 	  'wenn kurz Blinken
			Portb.3 = 1        'LED AN
			Waitms 30 	 'kurz warten
			Portb.3 = 0        'LED AUS
			Waitms 1000        'lang warten
		Else 		      'sonst lang blinken
			Portb.3 = 1        'LED AN
			Waitms 300 	'lange warten
			Portb.3 = 0        'LED AUS
			Waitms 1000        'lang warten
		End If
	Next A
Return

End